// Buruiana Filip Cristian
// castori - 100 de puncte

#include <stdio.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

#define INF 100000005
#define EPS 1e-8
#define maxim(a, b) ((a > b) ? a : b)
#define minim(a, b) ((a < b) ? a : b)
#define PDD pair<double, double>
#define SQRT2 1.414213562373
#define x first
#define y second
#define AMax 65536
#define NMax 10055

typedef struct { double x, y1, y2; int tip; } event;
typedef struct { int suma, bst; } entry;

int N, K;
PDD P[NMax];
event E[NMax<<1]; int ev;
entry A[AMax];

int cmpDouble(double a, double b)
{
    if (a + EPS < b)
        return -1;
    if (b + EPS < a)
        return +1;
    return 0;
}

int cmpEvent(const event& a, const event& b)
{
    if (a.x + EPS < b.x)
        return 1;
    if (b.x + EPS < a.x)
        return 0;
    // pentru abscise egale intai introducem evenimentele
    // de intrare, apoi cele de iesire
    return a.tip > b.tip;
}

int query(int n, int l, int r, int a, int b, int sum)
{
    if (a <= l && r <= b)
        return A[n].bst + sum;
    
    int m = (l + r) / 2, i1 = 0, i2 = 0;
    if (a <= m)
        i1 = query(2*n, l, m, a, b, sum + A[n].suma);
    if (b > m)
        i2 = query(2*n+1, m+1, r, a, b, sum + A[n].suma);

    return A[n].bst;
}

void update(int n, int l, int r, int a, int b, int semn)
{
    if (a <= l && r <= b)
    {
        A[n].suma += semn;
        A[n].bst += semn;
        return ;
    }
    int m = (l + r) / 2;
    if (a <= m)
        update(2*n, l, m, a, b, semn);
    if (b > m)
        update(2*n+1, m+1, r, a, b, semn);
    A[n].bst = A[n].suma + maxim(A[2*n].bst, A[2*n+1].bst);
}

double Y[4*NMax];

inline int BS(double ys, int n)
{
    int st = 0, dr = n-1, mid;
    
    while (st <= dr)
    {
        mid = (st + dr) / 2;
        if (Y[mid] + EPS < ys)
            st = mid+1;
        else if (ys + EPS < Y[mid])
            dr = mid-1;
        else
            return mid;     
    }
    return -1; // Safe Check
}

int normalize()
{
    int i, n = 0;
    
    for (i = 0; i < ev; ++i)
    {
        Y[n++] = E[i].y1;
        Y[n++] = E[i].y2; 
    }
    sort(Y, Y+n);
    int nr = 1;
    for (i = 1; i < n; ++i)
        if (cmpDouble(Y[nr-1], Y[i]) != 0)
            Y[nr++] = Y[i];
    n = nr;

    for (i = 0; i < ev; ++i)
    {
        E[i].y1 = BS(E[i].y1, n);
        E[i].y2 = BS(E[i].y2, n);
        if (E[i].y1 == -1 || E[i].y2 == -1)
        {
            fprintf(stderr, "Eroare la normalizare!\n");
            exit(2);
        }
    }
    
    return n;
}

inline bool check(int D)
{
    int i;
    
    ev = 0;
    for (i = 1; i <= N; ++i)
    {
        double latura = (double)D / SQRT2;
        
        E[ev].x = P[i].x - latura / 2;
        E[ev].y1 = P[i].y - latura / 2;
        E[ev].y2 = E[ev].y1 + latura;
        E[ev].tip = +1; // eveniment de intrare
        ++ev;
        
        E[ev].x = P[i].x + latura / 2;
        E[ev].y1 = P[i].y - latura / 2;
        E[ev].y2 = E[ev].y1 + latura;
        E[ev].tip = -1; // eveniment de iesire
        ++ev;
    }
    int yn = normalize();
    sort(E, E+ev, cmpEvent);
    int bst = 0;
    for (i = 0; i < AMax; ++i)
        A[i].suma = A[i].bst = 0;
        
    for (i = 0; i < ev; ++i)
    {
        update(1, 0, yn-1, (int)E[i].y1, (int)E[i].y2, E[i].tip);
        int cnt = query(1, 0, yn-1, (int)E[i].y1, (int)E[i].y2, 0);
        if (E[i].tip == +1)
            bst = maxim(bst, cnt);
        else
            cnt = 0;
    }
    return (bst >= K);
}

int main()
{
    int i, cx, cy, m1 = INF, M1 = -INF, m2 = INF, M2 = -INF;
    int lo, hi, mid, sol;
    
    freopen("castori.in", "r", stdin);
    freopen("castori.out", "w", stdout);
    
    scanf("%d %d", &N, &K);
    for (i = 1; i <= N; ++i)
    {
        scanf("%d %d", &cx, &cy);
        m1 = minim(m1, cx);
        m2 = minim(m2, cy);
        M1 = maxim(M1, cx);
        M2 = maxim(M2, cy);
        P[i].x = (cx-cy) / SQRT2;
        P[i].y = (cx+cy) / SQRT2;
    }

    lo = 0; hi = M1-m1 + M2-m2;
    mid = (lo+hi)/2;
    for (; lo <= hi; mid = (lo + hi) / 2)
    {
        if (check(mid))
        {
            hi = mid-1;
            sol = mid;
        }
        else
            lo = mid+1;
    }
    
    printf("%d\n", sol);
    
    return 0;
}
