// Buruiana Filip Cristian
// castori - 40 de puncte

#include <stdio.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

#define EPS 1e-8
#define maxim(a, b) ((a > b) ? a : b)
#define ll long long
#define PDD pair<double, double>
#define SQRT2 1.414213562373
#define x first
#define y second
#define AMax 131072
#define NMax 25055

typedef struct { double x, y1, y2; int tip; } event;

int N, K;
PDD P[NMax];
event E[NMax<<1]; int ev;
int A[3*NMax];

int cmpDouble(double a, double b)
{
    if (a + EPS < b)
        return -1;
    if (b + EPS < a)
        return +1;
    return 0;
}

int cmpEvent(const event& a, const event& b)
{
    if (a.x + EPS < b.x)
        return 1;
    if (b.x + EPS < a.x)
        return 0;
    // pentru abscise egale intai introducem evenimentele
    // de intrare, apoi cele de iesire
    return a.tip > b.tip;
}

int query(int a, int b)
{
    int i, mx = 0;
    
    for (i = a; i <= b; ++i)
        mx = maxim(mx, A[i]);
    return mx;
}

void update(int a, int b, int semn)
{
    int i;
    
    for (i = a; i <= b; ++i)
        A[i] += semn;
}

double Y[4*NMax];

inline int BS(double ys, int n)
{
    int st = 0, dr = n-1, mid;
    
    while (st <= dr)
    {
        mid = (st + dr) / 2;
        if (Y[mid] + EPS < ys)
            st = mid+1;
        else if (ys + EPS < Y[mid])
            dr = mid-1;
        else
            return mid;     
    }
    return -1; // Safe Check
}

int normalize()
{
    int i, n = 0;
    
    for (i = 0; i < ev; ++i)
    {
        Y[n++] = E[i].y1;
        Y[n++] = E[i].y2;
    }
    sort(Y, Y+n);

    int nr = 1;
    for (i = 1; i < n; ++i)
        if (cmpDouble(Y[nr-1], Y[i]) != 0)
            Y[nr++] = Y[i];
    n = nr;

    for (i = 0; i < ev; ++i)
    {
        E[i].y1 = BS(E[i].y1, n);
        E[i].y2 = BS(E[i].y2, n);
        if (E[i].y1 == -1 || E[i].y2 == -1)
        {
            fprintf(stderr, "Eroare la normalizare!\n");
            exit(2);
        }
    }
    
    return n;
}

inline bool check(int D)
{
    int i;
    
    ev = 0;
    for (i = 1; i <= N; ++i)
    {
        double latura = (double)D / SQRT2;
        
        E[ev].x = P[i].x - latura / 2;
        E[ev].y1 = P[i].y - latura / 2;
        E[ev].y2 = E[ev].y1 + latura;
        E[ev].tip = +1; // eveniment de intrare
        ++ev;
        
        E[ev].x = P[i].x + latura / 2;
        E[ev].y1 = P[i].y - latura / 2;
        E[ev].y2 = E[ev].y1 + latura;
        E[ev].tip = -1; // eveniment de iesire
        ++ev;
    }
    int yn = normalize();

    sort(E, E+ev, cmpEvent);  
    int bst = 0;

    for (i = 0; i < 3*NMax; ++i)
        A[i] = 0;        
    for (i = 0; i < ev; ++i)
    {
        update((int)E[i].y1, (int)E[i].y2, E[i].tip);
        int cnt = query((int)E[i].y1, (int)E[i].y2);
        if (E[i].tip == +1)
            bst = maxim(bst, cnt);
        else
            cnt = 0;
    }
    return (bst >= K);
}

int main()
{
    int i, cx, cy;
    int lo, hi, mid, sol;
    
    freopen("castori.in", "r", stdin);
    freopen("castori.out", "w", stdout);
    
    scanf("%d %d", &N, &K);
    for (i = 1; i <= N; ++i)
    {
        scanf("%d %d", &cx, &cy);
        P[i].x = (cx-cy) / SQRT2;
        P[i].y = (cx+cy) / SQRT2;
    }
    
    lo = 1; hi = 200000000;
    mid = (lo+hi)/2;
    for (; lo <= hi; mid = (lo + hi) / 2)
    {
        if (check(mid))
        {
            hi = mid-1;
            sol = mid;
        }
        else
            lo = mid+1;
    }
    
    printf("%d\n", sol);
    
    return 0;
}
