#include <fstream>
#include <algorithm>

using namespace std;

#define MAXN 10010
#define MAXM 20010
#define MAXX 32768
#define INF 1000000000

int N, M, K, L, Sol;
int Left, Right, Value;
int A[MAXN], B[MAXN], Q[MAXN];
int X[MAXM], V[MAXM], P[MAXM];
int Y[MAXM];
int C[MAXX], Best[MAXX];

int cmp(int i, int j)
{
	return X[i] < X[j];
}

int cmp2(int i, int j)
{
	return B[i] < B[j];
}

int search(int x)
{
	int front = 1, middle, back = N, Rez = 0;

	while (front <= back)
	{
		middle = (front + back) / 2;

		if (x >= B[Q[middle]])
		{
			Rez = middle;
			front = middle + 1;
		}
		else back = middle - 1;
	}

	return Rez;
}

void update(int p, int r, int nod)
{
	if (Left <= p && r <= Right) C[nod] += Value;
	else {
		  	int q = (p+r) / 2;

			if (Left <= q) update(p, q, nod*2);
			if (q < Right) update(q+1, r, nod*2+1);
		 }
		 
	if (p == r) Best[nod] = C[nod];
	else Best[nod] = max(Best[nod*2], Best[nod*2+1]) + C[nod];
}

int works(int D)
{
	int i, j, Rez = 0;

	M = 0;

	for (i = 1; i <= N; i++)
	{
		X[++M] = A[i], Y[M] = B[i], V[M] = 1, P[M] = M;
		X[++M] = A[i] + D + 1, Y[M] = B[i], V[M] = -1, P[M] = M;
	}

	for (L = 1; L < N; L <<= 1);

	sort(P+1, P+M+1, cmp);

	for (i = 1; i <= M; )
	{
		for (j = i; i <= M && X[P[i]] == X[P[j]]; i++)
		{
			Left = search(Y[P[i]]);
			Right = search(Y[P[i]] + D);
			Value = V[P[i]];

			update(1, L, 1);
		}

		Rez = max(Rez, Best[1]);
	}

	return Rez >= K;
}

int main()
{
	ifstream fin("10-castori.in");
	ofstream fout("castori.out");

	int i, x, y;
	int front = 0, middle, back = INF;

	fin >> N >> K;

	for (i = 1; i <= N; i++) 
	{
		fin >> x >> y;
		A[i] = x - y;
		B[i] = x + y;
		Q[i] = i;
	}

	sort(Q+1, Q+N+1, cmp2);

	while (front <= back)
	{
		middle = (front + back) / 2;

		if (works(middle)) 
		{
			Sol = middle;
			back = middle - 1;
		}
		else front = middle + 1;
	}

	fout << Sol << endl;

	return 0;
}
