#include <cstdio>
#include <cassert>
#include <algorithm>
using namespace std;

#define MAXN  450000
#define MAX_BUFFER_SIZE  1 << 24

const char iname[] = "secv.in";
const char oname[] = "secv.out";

int vect[MAXN];

char buffer[MAX_BUFFER_SIZE];

inline char parseChar(char* &i, char* limit) {
    while (i < limit && *i < 'A' || *i > 'Z')    ++ i;
    if (i < limit)  return *(i ++);
    return 0;
}

inline int parseInt(char* &i) {
    int in = 0;
    while (*i < '0' || *i > '9')    ++ i;
    while (*i >= '0' && *i <= '9')  in = in * 10 + (*i - '0'), ++ i;
    return in;
}

int main(int argc, char* argv[]) {
    FILE *fi = fopen(iname, "rt"), *fo = fopen(oname, "wt");
    char ch;
    int i, j, x, count = 0;

    int sz;
    buffer[ sz = fread(buffer, 1, MAX_BUFFER_SIZE, fi) ] = 0;
    char *cur_p = buffer, *limit = buffer + sz;

    while ( ch = parseChar(cur_p, limit) ) {
        if (ch == 'I') {
            i = parseInt(cur_p), x = parseInt(cur_p);
            i --;
            for (int j = count; j > i; -- j)
                vect[j] = vect[j - 1];
            vect[i] = x;
            ++ count;
        }
        if (ch == 'A') {
            i = parseInt(cur_p);
            fprintf(fo, "%d\n", vect[i - 1]);
        }
        if (ch == 'R') {
            i = parseInt(cur_p), j = parseInt(cur_p);
            i -- , j --;
            for (; i < j; ++ i, -- j) {
                int aux = vect[i];
                vect[i] = vect[j], vect[j] = aux;
            }
        }
        if (ch == 'D') {
            i = parseInt(cur_p), j = parseInt(cur_p);
            i --, j --;
            int l = j-i+1;
            for (j += 1; j < count; ++ j, ++ i)
                vect[i] = vect[j];
            count -= l;
        }
    }
    for (i = 0; i < count; ++ i)   fprintf(fo, "%d ", vect[i]);

    fcloseall();
    return 0;
}
