#include <cstdlib>
#include <ctime>
#include <fstream>
#include <algorithm>
using namespace std;

const int MAX_N = 64;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

ifstream fin, fout;
int x, y;
int n, m;
int a[MAX_N][MAX_N];

void drop(int pct, const char* msg) {
	printf("%d %s", pct, msg);
	exit(0);
}

int ok() {
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			if (i < n || j < m)
				if (a[i][j] != (i - 1) * m + j)
					return 0;
	return a[n][m] == 0;
}

int makeMove(int k) {
	int newx = x + dx[k];
	int newy = y + dy[k];
	if (newx < 1 || newx > n || newy < 1 || newy > m) return 0;
	swap(a[x][y], a[newx][newy]);
	x = newx;
	y = newy;
	return 1;
}

int main() {
	srand(time_t(0));
	fin.open("perspico.in");
	fout.open("perspico.out");
	if (!fin.good()) drop(0, "Fisier de intrare inexistent!");
	if (!fout.good()) drop(0, "Fisier de iesire inexistent!");

	fin >> n >> m;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			fin >> a[i][j];

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j)
			if (!a[i][j]) {
				x = i;
				y = j;
			}

	int val;
	while (fout >> val) {
		if (val < 1 || val > 4) drop(0, "Mutare inexistenta!");
		if (!makeMove(val-1)) drop(0, "Mutare in afara matricei!");
	}

	if (!ok()) drop(0, "Elementele matricei nu se regasesc pe pozitiile corespunzatoare!");
	drop(5, ((n + m) & 1) ? "Miruna iti face cu ochiul, te place!" : "Un pupic de la Miruna!");
}
